/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

/*
 * This file describes the layout of a GVP series II SCSI controller
 * (product 11) as understood by Niklas Hallqvist (niklas@appli.se).
 * Note: this info is not hard facts, but rather guesses.
 */

#ifndef _amiga_gvp11_h
#define _amiga_gvp11_h

#define PHYS_GVP11_DMAC 0xe90000 /* Should be gotten from autoconfig */

struct gvp11_dmac_t {
  u_short _____________pad0[32];
  u_short control;
  u_short _____________pad1[15];
  u_char  _____________pad2;
  u_char  wd_address;
  u_char  _____________pad3;
  u_char  wd_data;
  u_short _____________pad4[2];
  u_short bank;
  u_short _____________pad5[3];
  void    *DMA_address;
  u_short secret1;	/* Initially store 0  here */
  u_short start_DMA;	/* strobe */
  u_short stop_DMA;	/* strobe */
  u_short secret2;	/* Initially store 1  here */
  u_short secret3;	/*         "       15  "   */
};

/* bits in `control' */
#define GVP11_DMAC_BUSY		(1<<0)
#define GVP11_DMAC_INT_PENDING	(1<<1)
#define GVP11_DMAC_INT_ENABLE	(1<<3)
#define GVP11_DMAC_DIR_WRITE	(1<<4)


#ifdef KERNEL
#define gvp11_dmac (*((volatile struct gvp11_dmac_t *)VM_GVP11_DMAC))
#define phys_gvp11_dmac (*((volatile struct gvp11_dmac_t *)PHYS_GVP11_DMAC))
#define GVP11_SCSI_ADDR (&gvp11_dmac._____________pad2)
#define PHYS_GVP11_SCSI_ADDR (&phys_gvp11_dmac._____________pad2)
#endif


#endif /* _amiga_gvp11_h */
/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

/*
 * This file describes the layout of a GVP series II SCSI controller
 * (product 11) as understood by Niklas Hallqvist (niklas@appli.se).
 * Note: this info is not hard facts, but rather guesses.
 */

#ifndef _amiga_gvp11_h
#define _amiga_gvp11_h

#define PHYS_GVP11_DMAC 0xe90000 /* Should be gotten from autoconfig */

struct gvp11_dmac_t {
  u_short _____________pad0[32];
  u_short control;
  u_short _____________pad1[15];
  u_char  _____________pad2;
  u_char  wd_address;
  u_char  _____________pad3;
  u_char  wd_data;
  u_short _____________pad4[2];
  u_short bank;
  u_short _____________pad5[3];
  void    *DMA_address;
  u_short secret1;	/* Initially store 0  here */
  u_short start_DMA;	/* strobe */
  u_short stop_DMA;	/* strobe */
  u_short secret2;	/* Initially store 1  here */
  u_short secret3;	/*         "       15  "   */
};

/* bits in `control' */
#define GVP11_DMAC_BUSY		(1<<0)
#define GVP11_DMAC_INT_PENDING	(1<<1)
#define GVP11_DMAC_INT_ENABLE	(1<<3)
#define GVP11_DMAC_DIR_WRITE	(1<<4)


#ifdef KERNEL
#define gvp11_dmac (*((volatile struct gvp11_dmac_t *)VM_GVP11_DMAC))
#define phys_gvp11_dmac (*((volatile struct gvp11_dmac_t *)PHYS_GVP11_DMAC))
#define GVP11_SCSI_ADDR (&gvp11_dmac._____________pad2)
#define PHYS_GVP11_SCSI_ADDR (&phys_gvp11_dmac._____________pad2)
#endif


#endif /* _amiga_gvp11_h */
